program Zahlorie;
uses
  crt,graph, dos, strings;

const
  Menueanzahl  = 7;
  F_Haupt      = 1;
  F_Spieler    = 2;
  F_Skill      = 3;
  F_Spieler1   = 4;
  F_Spieler2   = 5;
  F_Spieler3   = 6;
  F_Spieler4   = 7;


  AbstandRahmen = 10;
  AbstandSchrift= 5;
  AbstandWert   = 100;
  AbstandEing   = 200;
  MaxMenuepunkte= 8;

  Spieleranzahl = 4; {Maximale Spieleranzahl}
  Balken        = 100;
  Abstz         = 50; {Abstand der Zahlen}
  xy            = 10; {Hhe und Breite der Vorzeichen}


type TMenuepunkt =
record
  Name: string; {Name des Menpunkts}
  Wahl: boolean;{Auswahl mglich?}
  Zahl: boolean;{Gibt es Werte zu verstellen}
  Wert: integer;{Eingestellter Wert}
  Max : integer;{Maximaler Wert}
  Min : integer;{Minimaler Wert}
  Eing: boolean;{Texteingabe?}
  Str : string; {Eingegebener Text}
  GoPro:string; {Name einer Procedure}
  GoFen:integer;{Name des neuen Fensters}
end;
type TMenue = array[1..Menueanzahl] of record
                  Titel      : string;     {Name des Fensters}
                  Punktanzahl: integer;    {Anzahl der Menpunkte}
                  Punkt      : array[1..Maxmenuepunkte] of TMenuepunkt;
              end;



var


  Menue       : TMenue;

  Datei   : file of TMenue;

  mittex,mittey: Integer;
  e           : integer; {Mllvariable}


  Graphdriver : Integer;
  Graphmode   : Integer;
  Errorcode   : Word;

  Feld        : array[1..64] of record
                                x,y,Zahl  : integer;
                                verdeckt  : boolean;
                                bekannt   : integer;
                end;
  Spieler     : array[1..4] of record
                                Farbe     : integer;
                                Triple    : integer;
                                Name      : string;
                                Computer  : boolean;
                                Dabei     : boolean;
                                Vz        : integer; {1 nach 1.Zahl
                                                      2 nach 2.Zahl
                                                      3.nach 3.Zahl}

                end;
  Feldanzahl    : integer;
  Speicher      : integer;  {Gedchnis des Computers}

  Beginnen    : boolean; {Spiel beginnen}
  beenden     : boolean; {Programm beenden}
  Aktiv       : integer;
  Offen       : array[1..3] of integer;
  Anzahl      : integer;
  Zugfertig   : boolean;
  Aktspieler  : integer;
  Hoehe,Breite: integer;
  Vorzeichen  : integer;

  Compaktuell : boolean;
  CompFeld    : array[1..3] of integer;
  CompVZ      : integer;
  Wert        : real;
  xr,yr       : Integer;
  mid         : record x : integer;
                       y : integer;
                end;


function check: boolean;
begin
  check := true;
  if Vorzeichen = 1 then
    if Feld[offen[1]].Zahl+Feld[offen[2]].Zahl <> Feld[offen[3]].Zahl then
    check := false;
  if Vorzeichen = 2 then
    if Feld[offen[1]].Zahl-Feld[offen[2]].Zahl <> Feld[offen[3]].Zahl then
    check := false;
  if Vorzeichen = 3 then
    if Feld[offen[1]].Zahl*Feld[offen[2]].Zahl <> Feld[offen[3]].Zahl then
    check := false;
  if Vorzeichen = 4 then
    if (Feld[offen[1]].Zahl mod Feld[offen[2]].Zahl <> 0) or
       (Feld[offen[1]].Zahl div Feld[offen[2]].Zahl <> Feld[offen[3]].Zahl)
    then check := false;
end;

procedure Aktuellzeichnen;
var
  i     : integer;
  s     : string;
begin
  for i := 1 to Feldanzahl do
  begin
    if Feld[i].verdeckt = true then
    begin
      setcolor(red);
      rectangle(feld[i].x,Feld[i].y,
                feld[i].x+Breite div Anzahl-5,
                feld[i].y+Hoehe div Anzahl-5);
      setfillstyle(solidfill,brown);
      floodfill(feld[i].x+1,Feld[i].y+1,red);
    end
    else
    begin
      setcolor(black);
      rectangle(feld[i].x,Feld[i].y,
                feld[i].x+Breite div Anzahl-5,
                feld[i].y+Hoehe div Anzahl-5);
      setfillstyle(solidfill,black);
      floodfill(feld[i].x+1,Feld[i].y+1,black);
    end;
    {if Feld[i].bekannt <> 0 then}    {Merkzahlen anzeigen}
    {  begin
        SetTextJustify(CenterText, Centertext);
        SetTextStyle(1,Horizdir,2);
        setcolor(yellow);
        str(Feld[i].bekannt,s);
        outTextxy(feld[i].x+10,Feld[i].y+10,s);
      end;}
  end;

  setcolor(black);
  setfillstyle(solidfill,black);
  bar(0,Hoehe,getmaxx,getmaxy);
  setcolor(darkgray);
  rectangle(0,Hoehe,getmaxx-7,getmaxy);
  setcolor(lightgray);
  rectangle(1,Hoehe+1,getmaxx-8,getmaxy-1);
  setcolor(white);
  rectangle(2,Hoehe+2,getmaxx-9,getmaxy-2);
  setcolor(darkgray);
  setfillstyle(solidfill,darkgray);
  bar(3,Hoehe+3,124,getmaxy-3);
  setcolor(lightgray);line(125,Hoehe+3,125,getmaxy-3);
  setcolor(white);line(126,Hoehe+3,126,getmaxy-3);
  setcolor(lightgray);line(127,Hoehe+3,127,getmaxy-3);
  setcolor(darkgray);line(128,Hoehe+3,128,getmaxy-3);

  for i:= 1 to Spieleranzahl do if spieler[i].dabei = true then
  begin
    if aktspieler = i then
    begin
      setcolor(yellow);
      setfillstyle(solidfill,yellow);
      bar(8,Hoehe+5+(Balken-10) div SpielerAnzahl * (i-1)+3,
          120,Hoehe+20+(Balken-10) div SpielerAnzahl * (i-1)+3);
    end;
    SetTextJustify(leftText, Centertext);
    SetTextStyle(2,Horizdir,5);
    if aktspieler = i then setcolor(Spieler[i].Farbe-8)
    else setcolor(Spieler[i].Farbe);
    outtextxy(10,
              Hoehe+10+(Balken-10) div SpielerAnzahl * (i-1)+3,
              Spieler[i].Name);
    str(Spieler[i].Triple,s);
    outTextxy(100,
              Hoehe+10+(Balken-10) div SpielerAnzahl * (i-1)+3,
              s);
  end;
end;

procedure Vorzeichenfinden;
var
  i             : integer;
  VZx, VZy      : array[1..4] of integer;
  Minusx,Minusy : integer;
  Malx, Maly    : integer;
  Divx, Divy    : integer;
  Taste         : char;
  fertig1,fertig2: boolean;

begin
  i := 1;
  Vorzeichen := 1;

  VZx[1] := getmaxx div 2 + i*Abstz+Abstz div 2 - xy div 2;
  VZy[1] := getmaxy-Balken+xy;

  VZx[2] := VZx[1];
  VZy[2] := getmaxy-Balken+3*xy;

  VZx[3] := VZx[1];
  VZy[3] := getmaxy-Balken+5*xy;

  VZx[4] := VZx[1];
  VZy[4] := getmaxy-Balken+7*xy;

  setcolor(lightred);
  line(VZx[1] + xy div 2, VZy[1], VZx[1] + xy div 2, VZy[1] + xy);
  line(VZx[1], VZy[1] + xy div 2, VZx[1] + xy, VZy[1] + xy div 2);

  line(VZx[2], VZy[2] + xy div 2, VZx[2] + xy, VZy[2] + xy div 2);

  line(VZx[3], VZy[3], VZx[3] + xy, VZy[3] + xy);
  line(VZx[3], VZy[3] + xy, VZx[3] + xy, VZy[3]);

  {line(VZx[4], VZy[4] + xy div 2, VZx[4] + xy, VZy[4] + xy div 2);}
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 4, lightred);
  putpixel(VZx[4] + xy div 2-1, VZy[4] + xy div 4, lightred);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 4-1, lightred);
  putpixel(VZx[4] + xy div 2+1, VZy[4] + xy div 4, lightred);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 4+1, lightred);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 2 + xy div 4, lightred);
  putpixel(VZx[4] + xy div 2-1, VZy[4] + xy div 2 + xy div 4, lightred);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 2 + xy div 4-1, lightred);
  putpixel(VZx[4] + xy div 2+1, VZy[4] + xy div 2 + xy div 4, lightred);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 2 + xy div 4+1, lightred);

  setcolor(white);
  rectangle(VZx[Vorzeichen],VZy[Vorzeichen],
            VZx[Vorzeichen]+xy,VZy[Vorzeichen]+xy);

  fertig1 := false;
  while fertig1 = false do
  begin
    if compaktuell then
    begin
      if (Vorzeichen - compVZ) > 0 then Taste := char(72) else
      if (Vorzeichen - compVZ) < 0 then Taste := char(80) else
      Taste := chr(13);
      delay(200)
    end
    else
    begin
      fertig2 := false;
      while fertig2 = false do
      begin
        repeat until keypressed;
        Taste := readkey;
        if (Taste = char(80)) or (Taste = char(72)) or
           (Taste = chr(13)) then Fertig2 := true;
      end;
    end;
    if Taste = char(80) then
    begin
      setcolor(black);
      rectangle(VZx[Vorzeichen],VZy[Vorzeichen],
                VZx[Vorzeichen]+xy,VZy[Vorzeichen]+xy);
      Vorzeichen := Vorzeichen + 1;
      if Vorzeichen > 4 then Vorzeichen := 1;
      setcolor(white);
      rectangle(VZx[Vorzeichen],VZy[Vorzeichen],
                VZx[Vorzeichen]+xy,VZy[Vorzeichen]+xy);
    end;
    if Taste = char(72) then
    begin
      setcolor(black);
      rectangle(VZx[Vorzeichen],VZy[Vorzeichen],
                VZx[Vorzeichen]+xy,VZy[Vorzeichen]+xy);
      Vorzeichen := Vorzeichen - 1;
      if Vorzeichen < 1 then Vorzeichen := 4;
      setcolor(white);
      rectangle(VZx[Vorzeichen],VZy[Vorzeichen],
                VZx[Vorzeichen]+xy,VZy[Vorzeichen]+xy);

    end;
    if Taste= chr(13) then fertig1 := true;
  end;

  setcolor(black);
  rectangle(VZx[Vorzeichen],VZy[Vorzeichen],
            VZx[Vorzeichen]+xy,VZy[Vorzeichen]+xy);
  line(VZx[1] + xy div 2, VZy[1], VZx[1] + xy div 2, VZy[1] + xy);
  line(VZx[1], VZy[1] + xy div 2, VZx[1] + xy, VZy[1] + xy div 2);

  line(VZx[2], VZy[2] + xy div 2, VZx[2] + xy, VZy[2] + xy div 2);

  line(VZx[3], VZy[3], VZx[3] + xy, VZy[3] + xy);
  line(VZx[3], VZy[3] + xy, VZx[3] + xy, VZy[3]);

  {line(VZx[4], VZy[4] + xy div 2, VZx[4] + xy, VZy[4] + xy div 2);}
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 4, black);
  putpixel(VZx[4] + xy div 2-1, VZy[4] + xy div 4, black);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 4-1, black);
  putpixel(VZx[4] + xy div 2+1, VZy[4] + xy div 4, black);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 4+1, black);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 2 + xy div 4, black);
  putpixel(VZx[4] + xy div 2-1, VZy[4] + xy div 2 + xy div 4, black);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 2 + xy div 4-1, black);
  putpixel(VZx[4] + xy div 2+1, VZy[4] + xy div 2 + xy div 4, black);
  putpixel(VZx[4] + xy div 2, VZy[4] + xy div 2 + xy div 4+1, black);


  setcolor(lightred);
  if Vorzeichen = 1 then
  begin
    line(VZx[1] + xy div 2, getmaxy-Balken div 2 - xy,
         VZx[1] + xy div 2, getmaxy-Balken div 2);
    line(VZx[1], getmaxy-Balken div 2 - xy + xy div 2,
         VZx[1] + xy, getmaxy-Balken div 2 - xy + xy div 2);
  end;
  if Vorzeichen = 2 then
  begin
    line(VZx[2], getmaxy-Balken div 2 - xy + xy div 2,
         VZx[2] + xy, getmaxy-Balken div 2 - xy + xy div 2);
  end;
  if Vorzeichen = 3 then
  begin
    line(VZx[3], getmaxy-Balken div 2 - xy,
         VZx[3] + xy, getmaxy-Balken div 2);
    line(VZx[3], getmaxy-Balken div 2,
         VZx[3] + xy, getmaxy-Balken div 2 - xy);
  end;
  if Vorzeichen = 4 then
  begin
    {line(VZx[4], getmaxy-Balken div 2 - xy + xy div 2,
         VZx[4] + xy, getmaxy-Balken div 2 - xy + xy div 2);}
    putpixel(VZx[4] + xy div 2,
             getmaxy-Balken div 2 - xy + xy div 4, lightred);
    putpixel(VZx[4] + xy div 2-1,
             getmaxy-Balken div 2 - xy + xy div 4, lightred);
    putpixel(VZx[4] + xy div 2,
             getmaxy-Balken div 2 - xy + xy div 4-1, lightred);
    putpixel(VZx[4] + xy div 2+1,
             getmaxy-Balken div 2 - xy + xy div 4, lightred);
    putpixel(VZx[4] + xy div 2,
             getmaxy-Balken div 2 - xy + xy div 4+1, lightred);

    putpixel(VZx[4] + xy div 2,
             getmaxy-Balken div 2 - xy + xy div 2 + xy div 4, lightred);
    putpixel(VZx[4] + xy div 2-1,
             getmaxy-Balken div 2 - xy + xy div 2 + xy div 4, lightred);
    putpixel(VZx[4] + xy div 2,
             getmaxy-Balken div 2 - xy + xy div 2 + xy div 4-1, lightred);
    putpixel(VZx[4] + xy div 2+1,
             getmaxy-Balken div 2 - xy + xy div 2 + xy div 4, lightred);
    putpixel(VZx[4] + xy div 2,
             getmaxy-Balken div 2 - xy + xy div 2 + xy div 4+1, lightred);

  end;
end;

function Gehtwas: boolean;
var
a,b,c    : integer;
begin
  Gehtwas := false;
  for a := 1 to Feldanzahl do
  begin
    if (Feld[a].verdeckt = true) then
      for b := 1 to Feldanzahl do
      begin
        if (Feld[b].verdeckt = true) and (b <> a) then
          for c := 1 to Feldanzahl do
          begin
            if (Feld[c].verdeckt = true) and (c <> a) and (c <> b) then
            begin
              if (Feld[a].Zahl + Feld[b].Zahl) = Feld[c].Zahl then Gehtwas := true;
              if (Feld[a].Zahl - Feld[b].Zahl) = Feld[c].Zahl then Gehtwas := true;
              if (Feld[a].Zahl * Feld[b].Zahl) = Feld[c].Zahl then Gehtwas := true;
              if (Feld[a].Zahl mod Feld[b].Zahl = 0)
                 and (Feld[a].Zahl div Feld[b].Zahl = Feld[c].Zahl) then Gehtwas := true;
            end;
          end;
      end;
   end;
end;

procedure compute;
var
a,b,c : integer;
Treffer: boolean;
begin
  Treffer := false;
  for a := 1 to Feldanzahl do
  begin
    if (Feld[a].verdeckt = true) and (Feld[a].bekannt <> 0) then
      for b := 1 to Feldanzahl do
      begin
        if (Feld[b].verdeckt = true) and (Feld[b].bekannt <> 0) and (b <> a) then
          for c := 1 to Feldanzahl do
          begin
            if (Feld[c].verdeckt = true) and (Feld[c].bekannt <> 0) and (c <> a) and (c <> b) then
            begin
              if (Feld[a].Zahl + Feld[b].Zahl) = Feld[c].Zahl then
              begin
                CompFeld[1] := a;
                CompFeld[2] := b;
                CompFeld[3] := c;
                CompVZ      := 1;
                Treffer := true;
              end;
              if (Feld[a].Zahl - Feld[b].Zahl) = Feld[c].Zahl then
              begin
                CompFeld[1] := a;
                CompFeld[2] := b;
                CompFeld[3] := c;
                CompVZ      := 2;
                Treffer := true;
              end;
              if (Feld[a].Zahl * Feld[b].Zahl) = Feld[c].Zahl then
              begin
                CompFeld[1] := a;
                CompFeld[2] := b;
                CompFeld[3] := c;
                CompVZ      := 3;
                Treffer := true;
              end;
              if (Feld[a].Zahl mod Feld[b].Zahl = 0)
                 and (Feld[a].Zahl div Feld[b].Zahl = Feld[c].Zahl) then
              begin
                CompFeld[1] := a;
                CompFeld[2] := b;
                CompFeld[3] := c;
                CompVZ      := 4;
                Treffer := true;
              end;
            end;
          end;
      end;
  end;
  if Treffer = false then
  begin
    repeat
       a := random(Feldanzahl)+1
    until (Feld[a].verdeckt = true) and (Feld[a].bekannt = 0);
    for b := 1 to Feldanzahl do
    begin
       if (Feld[b].verdeckt = true) and (Feld[b].bekannt <> 0) and (b <> a) then
        for c := 1 to Feldanzahl do
        begin
          if (Feld[c].verdeckt = true) and (Feld[c].bekannt <> 0) and (c <> a) and (c <> b) then
          begin
            if (Feld[a].Zahl + Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              CompVZ      := 1;
              Treffer := true;
            end;
            if (Feld[a].Zahl - Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              CompVZ      := 2;
              Treffer := true;
            end;
            if (Feld[a].Zahl * Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              CompVZ      := 3;
              Treffer := true;
            end;
            if (Feld[a].Zahl mod Feld[b].Zahl = 0)
               and (Feld[a].Zahl div Feld[b].Zahl = Feld[c].Zahl) then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              CompVZ      := 4;
              Treffer := true;
            end;
          end;
        end;
    end;
    if Treffer = false then
    begin
      repeat
        b := random(Feldanzahl)+1
      until (Feld[b].verdeckt = true) and (b <> a) and (Feld[a].bekannt = 0);
      if Spieler[Aktspieler].Vz = 1 then CompVZ := random(3)+1;
      for c := 1 to Feldanzahl do
        begin
          if (Feld[c].verdeckt = true) and (Feld[c].bekannt <> 0) and (c <> a) and (c <> b) then
          begin
            if ((Spieler[Aktspieler].Vz=1) and (CompVZ = 1)) or
                (Spieler[Aktspieler].Vz<>1) then
            if (Feld[a].Zahl + Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>1 then CompVZ := 1;
              Treffer := true;
            end;
            if ((Spieler[Aktspieler].Vz=1) and (CompVZ = 2)) or
                (Spieler[Aktspieler].Vz<>1) then
            if (Feld[a].Zahl - Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>1 then CompVZ := 2;
              Treffer := true;
            end;
            if ((Spieler[Aktspieler].Vz=1) and (CompVZ = 3)) or
                (Spieler[Aktspieler].Vz<>1) then
            if (Feld[a].Zahl * Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>1 then CompVZ := 3;
              Treffer := true;
            end;
            if ((Spieler[Aktspieler].Vz=1) and (CompVZ = 4)) or
                (Spieler[Aktspieler].Vz<>1) then
            if (Feld[a].Zahl mod Feld[b].Zahl = 0)
               and (Feld[a].Zahl div Feld[b].Zahl = Feld[c].Zahl) then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>1 then CompVZ := 4;
              Treffer := true;
            end;
          end;
        end;
      if Treffer = false then
      begin
        repeat
          c := random(Feldanzahl)+1
        until (Feld[c].verdeckt = true) and (c <> a) and (c <> b)
               and (Feld[a].bekannt = 0);
        if Spieler[Aktspieler].Vz = 2 then CompVZ := random(3)+1;
        if (Feld[c].verdeckt = true) and (Feld[c].bekannt <> 0) and (c <> a) and (c <> b) then
        begin
            if ((Spieler[Aktspieler].Vz=2) and (CompVZ = 1)) or
                (Spieler[Aktspieler].Vz<>2) then
            if (Feld[a].Zahl + Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>2 then CompVZ := 1;
              Treffer := true;
            end;
            if ((Spieler[Aktspieler].Vz=2) and (CompVZ = 2)) or
                (Spieler[Aktspieler].Vz<>2) then
            if (Feld[a].Zahl - Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>2 then CompVZ := 2;
              Treffer := true;
            end;
            if ((Spieler[Aktspieler].Vz=2) and (CompVZ = 3)) or
                (Spieler[Aktspieler].Vz<>2) then
            if (Feld[a].Zahl * Feld[b].Zahl) = Feld[c].Zahl then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>2 then CompVZ := 3;
              Treffer := true;
            end;
            if ((Spieler[Aktspieler].Vz=2) and (CompVZ = 4)) or
                (Spieler[Aktspieler].Vz<>2) then
            if (Feld[a].Zahl mod Feld[b].Zahl = 0)
               and (Feld[a].Zahl div Feld[b].Zahl = Feld[c].Zahl) then
            begin
              CompFeld[1] := a;
              CompFeld[2] := b;
              CompFeld[3] := c;
              if Spieler[Aktspieler].Vz<>2 then CompVZ := 4;
              Treffer := true;
            end;
        end;
      end;
    end;
  end;
  if Treffer = false then
  begin
    CompFeld[1] := a;
    CompFeld[2] := b;
    CompFeld[3] := c;
    if Spieler[Aktspieler].Vz = 3 then CompVZ := random(3)+1;
  end;
end;


procedure Zug;
var
  fertig1,fertig2 : boolean;
  Taste,Taste2    : char;
  i,j             : integer;
  s               : string;
  Aktuell         : integer; {Bei welchem Feld zwischen 1 und 3}
begin
  aktuellzeichnen;
  fertig1 := false;
  for i := 1 to 3 do Offen[i]:=0;
  Aktuell := 1;
  Aktiv   := 1;
  setcolor(white);
  rectangle(feld[Aktiv].x,Feld[Aktiv].y,
            feld[Aktiv].x+Breite div Anzahl-5,
            feld[Aktiv].y+Hoehe div Anzahl-5);
  while fertig1 = false do
  begin
    if compaktuell then
    begin
      if Feld[aktiv].x > Feld[compfeld[Aktuell]].x then Taste := char(75)
      else if Feld[aktiv].x < Feld[compfeld[Aktuell]].x then Taste := char(77)
           else if Feld[aktiv].y > Feld[compfeld[Aktuell]].y then Taste := char(72)
                else if Feld[aktiv].y < Feld[compfeld[Aktuell]].y then Taste := char(80)
                     else Taste := chr(13);
      delay(200);
      if keypressed then
      begin
        Taste2 := readkey;
        if Taste2 = chr(27) then Taste := Taste2;
      end;
    end
    else
    begin
      fertig2 := false;
      while fertig2 = false do
      begin
        repeat until keypressed;
        Taste := readkey;
        if (Taste = char(80)) or (Taste = char(72)) or
           (Taste = char(77)) or (Taste = char(75)) or
           (Taste =  chr(13)) or (Taste =  chr(27))
           then Fertig2 := true;
      end;
    end;
    if (Feld[Aktiv].verdeckt=true) then setcolor(red)
    else setcolor(black);
    rectangle(feld[Aktiv].x,Feld[aktiv].y,
              feld[Aktiv].x+Breite div Anzahl-5,
              feld[Aktiv].y+Hoehe div Anzahl-5);

    if Taste = char(80) then
    begin
      Aktiv := Aktiv + Anzahl;
      if Aktiv > Feldanzahl then Aktiv := aktiv- Feldanzahl;
    end;
    if Taste = char(72) then
    begin
      Aktiv := Aktiv - Anzahl;
      if Aktiv < 1 then Aktiv := Aktiv+Feldanzahl;
    end;
    if Taste = char(77) then
    begin
      Aktiv := Aktiv + 1;
      if Aktiv > Feldanzahl then Aktiv := 1;
    end;
    if Taste = char(75) then
    begin
      Aktiv := Aktiv - 1;
      if Aktiv < 1 then Aktiv := Feldanzahl;
    end;

    if Taste = chr(27) then
    begin
      beginnen := false;
      exit;
    end;
    if (Taste = chr(13)) and (Feld[Aktiv].verdeckt=true) and
       (Aktiv <> offen[1]) and (Aktiv <> offen[2]) and
       (Aktiv <> offen[3]) then
    begin
      for i:= 1 to 3 do if offen[i] = 0 then
      begin
        if i >= 3 then fertig1 := true;
        offen[i] := aktiv;
        setfillstyle(solidfill,green);
        floodfill(feld[offen[i]].x+1,feld[offen[i]].y+1,red);
        SetTextJustify(CenterText, Centertext);
        SetTextStyle(1,Horizdir,5);
        setcolor(lightred);
        str(Feld[offen[i]].Zahl,s);
        outTextxy(feld[offen[i]].x+Breite div Anzahl div 2,
                  feld[offen[i]].y+Hoehe div Anzahl div 2-10,
                  s);

        SetTextJustify(CenterText, Centertext);
        SetTextStyle(1,Horizdir,4);
        setcolor(lightred);
        str(Feld[offen[i]].Zahl,s);
        outTextxy(getmaxx div 2 + i*50, getmaxy-Balken div 2-10, s);

        sound(300);
        delay(100);
        nosound;

        for j := 1 to Feldanzahl do
          if (feld[j].bekannt <> 0) then
            begin
              inc(feld[j].bekannt,1);
              if feld[j].bekannt > Speicher then feld[j].bekannt := 0;
            end;
        feld[Aktiv].bekannt := 1;

        if i=Spieler[Aktspieler].Vz then
        begin
          setcolor(red);
          rectangle(feld[Aktiv].x,Feld[aktiv].y,
                    feld[Aktiv].x+Breite div Anzahl-5,
                    feld[Aktiv].y+Hoehe div Anzahl-5);
          vorzeichenfinden;
        end;
        if i=2 then
        begin
          setcolor(lightred);
          line(getmaxx div 2 + i*Abstz+Abstz div 2 - xy div 2,
               getmaxy-Balken div 2-xy,
               getmaxx div 2 + i*Abstz+Abstz div 2 + xy div 2,
               getmaxy-Balken div 2-xy);
          line(getmaxx div 2 + i*Abstz+Abstz div 2 - xy div 2,
               getmaxy-Balken div 2-2,
               getmaxx div 2 + i*Abstz+Abstz div 2 + xy div 2,
               getmaxy-Balken div 2-2);
        end;

        inc(Aktuell);
        break;
      end;

      if (fertig1 = true) and (check = false) then
      begin
        sound(200);
        delay(100);
        sound(100);
        delay(100);
        nosound;
        delay(1000);
      end;

      if (fertig1 = true) and (check = true) then
      begin
        for i := 1 to 3 do
        begin
          feld[offen[i]].verdeckt:=false;
        end;
        Zugfertig := true;
        sound(600);
        delay(100);
        sound(400);
        delay(100);
        Spieler[Aktspieler].triple := Spieler[Aktspieler].triple + 1;
        nosound;
        delay(1000);
      end;
    end;
    if fertig1 = false then
    begin
      setcolor(white);
      rectangle(feld[Aktiv].x,Feld[Aktiv].y,
                feld[Aktiv].x+Breite div Anzahl-5,
                feld[Aktiv].y+Hoehe div Anzahl-5);
    end;
  end;
end;



procedure Spiel;
var
  Taste : char;
  i,j,a,b : integer;
  Fehler: boolean;
  test  : record
                s : array[1..4] of boolean; {Welcher Spieler}
                p : integer; {Punktzahl}
          end;
  s1,s2 : string;

begin
  for i := 1 to 100 do
  begin
    aktspieler := aktspieler -1;
    if aktspieler < 1 then aktspieler := Spieleranzahl;
    Fehler := true;
    for j := 1 to 4 do
    begin
      if spieler[j].dabei = true then Fehler := false;
    end;
    if fehler = true then
    begin
      SetTextJustify(CenterText, Centertext);
      SetTextStyle(1,Horizdir,3);
      setcolor(yellow);
      outTextxy(getmaxx div 2, getmaxy div 2, 'Es mu mindestens ein Spieler mitspielen');
      readln;
      exit;
    end;
    Zugfertig := false;
    while zugfertig = false do
    begin
      aktspieler := aktspieler +1;
      if aktspieler > Spieleranzahl then aktspieler := 1;
      if spieler[aktspieler].dabei = true then
      begin
        if spieler[aktspieler].computer = true then
        begin
          compute;
          compaktuell := true;
        end
        else compaktuell := false;
        delay(1000);
        zug;
        if beginnen = false then exit;
        if not Gehtwas then
        begin
          Aktuellzeichnen;
          SetTextJustify(CenterText, Centertext);
          SetTextStyle(1,Horizdir,7);
          setcolor(yellow);
          outTextxy(getmaxx div 2, getmaxy div 2-50, 'Nichts geht mehr');
          for j := 1 to 4 do test.s[j] := false;
          test.p := 0;
          s1     := '';
          s2     := '';
          a      := 0;
          for j := 1 to 4 do
          begin
            if (spieler[j].triple > test.p) and spieler[j].dabei then
            begin
              for b:= 1 to j-1 do
              begin
                test.s[b] := false;
                dec(a);
              end;
            end;
            if (spieler[j].triple >= test.p) and spieler[j].dabei then
            begin
              inc(a);
              test.s[j] := true;
              test.p := spieler[j].triple;
            end;
          end;
          SetTextStyle(1,Horizdir,3);

          b:= 0;
          for j := 1 to 4 do
          begin
            if test.s[j] then
            begin
              inc(b);
              if (b<=2) then
              begin
                if b = 1 then s1 := spieler[j].Name
                else
                begin
                  if b=a then s1 := s1+' und '+spieler[j].Name
                  else  s1 := s1+', '+spieler[j].Name
                end;
              end
              else
              begin
                if b=a then s2 := s2+' und '+spieler[j].Name
                else  s2 := s2+', '+spieler[j].Name
              end;
            end;
          end;
          if a > 2 then s2 := s2+' haben gewonnen'
          else
          begin
            if a > 1 then s1 := s1+' haben gewonnen'
            else s1 := s1+' hat gewonnen';
          end;
          outTextxy(getmaxx div 2, (getmaxy div 2)+50, s1);
          if s2 <> '' then outTextxy(getmaxx div 2, (getmaxy div 2)+100, s2);

          readln;
          exit;
        end;
      end;
    end;
  end;
end;

procedure Aufbau;
var
  i,j,k        : Integer;
  s            : string;

begin
  for i := 1 to 4 do
  begin
    spieler[i].triple := 0;
  end;

  k:=1;
  Aktiv := 1;
  Feldanzahl := menue[F_Skill].Punkt[1].wert;

  if menue[F_Skill].Punkt[2].wert = 4 then Speicher := 64;
  if menue[F_Skill].Punkt[2].wert = 3 then Speicher := 10;
  if menue[F_Skill].Punkt[2].wert = 2 then Speicher := 5;
  if menue[F_Skill].Punkt[2].wert = 1 then Speicher := 1;

  Anzahl := round(sqrt(Feldanzahl));
  Aktspieler := random(Spieleranzahl)+1;
  for i := 1 to Anzahl do
    for j := 1 to Anzahl do
    begin
      Feld[k].x := Breite div Anzahl*(j-1);
      Feld[k].y := Hoehe div Anzahl*(i-1);
      k:=k+1;
    end;
  for i := 1 to Feldanzahl do
  begin
    Feld[i].verdeckt := true;
    Feld[i].Zahl     := random(9)+1;
    Feld[i].bekannt  := 0;
  end;
  for i := 1 to Spieleranzahl do
  begin
    spieler[i].Farbe:=i+8;
    Spieler[i].Computer := false;
    Spieler[i].dabei := true;
  end;
  Spieler[1].Name     := menue[F_Spieler1].Punkt[1].str;
  Spieler[1].Vz := 4-menue[F_Spieler1].Punkt[2].wert;
  if menue[F_Spieler1].Punkt[3].wert = 0 then
    Spieler[1].Computer := true;
  if menue[F_Spieler1].Punkt[4].wert = 1 then
    Spieler[1].dabei := false;

  Spieler[2].Name     := menue[F_Spieler2].Punkt[1].str;
  Spieler[2].Vz := 4-menue[F_Spieler2].Punkt[2].wert;
  if menue[F_Spieler2].Punkt[3].wert = 0 then
    Spieler[2].Computer := true;
  if menue[F_Spieler2].Punkt[4].wert = 1 then
    Spieler[2].dabei := false;

  Spieler[3].Name     := menue[F_Spieler3].Punkt[1].str;
  Spieler[3].Vz := 4-menue[F_Spieler3].Punkt[2].wert;
  if menue[F_Spieler3].Punkt[3].wert = 0 then
    Spieler[3].Computer := true;
  if menue[F_Spieler3].Punkt[4].wert = 1 then
    Spieler[3].dabei := false;

  Spieler[4].Name     := menue[F_Spieler4].Punkt[1].str;
  Spieler[4].Vz := 4-menue[F_Spieler4].Punkt[2].wert;
  if menue[F_Spieler4].Punkt[3].wert = 0 then
    Spieler[4].Computer := true;
  if menue[F_Spieler4].Punkt[4].wert = 1 then
    Spieler[4].dabei := false;


end;


procedure DP3D(Timer: integer);
begin

  setcolor(black);
  ellipse(mid.x,mid.y,0,360,Abs(xr),yr);
  ellipse(mid.x,mid.y- yr div 2,0,360,Abs(xr div 4),yr div 2);
  ellipse(mid.x,mid.y+ yr div 2,0,360,Abs(xr div 4),yr div 2);
  line(mid.x- xr div 4,mid.y-yr+5,mid.x- xr div 4,mid.y+yr-5);
  line(mid.x+ xr div 4,mid.y-yr+5,mid.x+ xr div 4,mid.y+yr-5);

  wert := Timer/1000;
  {if wert > 2*pi then wert:=0;}
  xr:=round(60*sin(Wert));

  if wert > pi then setcolor(lightgray) else setcolor(white);
  ellipse(mid.x,mid.y,0,360,Abs(xr),yr);
  if wert > pi then setcolor(red) else setcolor(lightred);
  ellipse(mid.x,mid.y- yr div 2,0,360,Abs(xr div 4),yr div 2);
  line(mid.x- xr div 4,mid.y-yr+5,mid.x- xr div 4,mid.y+yr-5);
  if wert > pi then setcolor(green) else setcolor(lightgreen);
  ellipse(mid.x,mid.y+ yr div 2,0,360,Abs(xr div 4),yr div 2);
  line(mid.x+ xr div 4,mid.y-yr+5,mid.x+ xr div 4,mid.y+yr-5);

  delay(50);


end;

procedure fenster(Mfenster: integer;var Erg: integer);
var
  Hoehe,Breite : integer;
  i,k        : integer;
  j          : integer;
  s            : string;
  Aktuell      : integer;
  key,key1     : char;
  schrifty     : array[1..Maxmenuepunkte] of integer;
  zaehler      : integer;
  NullStr      : array[0..255] of Char;

begin
  setcolor(white);
  putpixel(getmaxx-20,getmaxy-20,white);
  putpixel(getmaxx-19,getmaxy-20,white);
  putpixel(getmaxx-18,getmaxy-20,white);
  putpixel(getmaxx-20,getmaxy-19,white);
  putpixel(getmaxx-20,getmaxy-18,white);
  putpixel(getmaxx-19,getmaxy-18,white);
  putpixel(getmaxx-20,getmaxy-17,white);
  putpixel(getmaxx-20,getmaxy-16,white);
  putpixel(getmaxx-19,getmaxy-16,white);
  putpixel(getmaxx-18,getmaxy-16,white);

  putpixel(getmaxx-16,getmaxy-20,white);
  putpixel(getmaxx-15,getmaxy-20,white);
  putpixel(getmaxx-14,getmaxy-20,white);
  putpixel(getmaxx-16,getmaxy-19,white);
  putpixel(getmaxx-16,getmaxy-18,white);
  putpixel(getmaxx-15,getmaxy-18,white);
  putpixel(getmaxx-14,getmaxy-18,white);
  putpixel(getmaxx-14,getmaxy-17,white);
  putpixel(getmaxx-14,getmaxy-16,white);
  putpixel(getmaxx-15,getmaxy-16,white);
  putpixel(getmaxx-16,getmaxy-16,white);

  putpixel(getmaxx-12,getmaxy-20,white);
  putpixel(getmaxx-11,getmaxy-20,white);
  putpixel(getmaxx-10,getmaxy-20,white);
  putpixel(getmaxx-12,getmaxy-19,white);
  putpixel(getmaxx-12,getmaxy-18,white);
  putpixel(getmaxx-12,getmaxy-17,white);
  putpixel(getmaxx-12,getmaxy-16,white);
  putpixel(getmaxx-11,getmaxy-16,white);
  putpixel(getmaxx-10,getmaxy-16,white);

  rectangle(getmaxx,getmaxy-3,getmaxx-30,getmaxy-29);
  rectangle(getmaxx-5,getmaxy-10,getmaxx-25,getmaxy-26);
  line(getmaxx,getmaxy-3,getmaxx-5,getmaxy-10);
  line(getmaxx-30,getmaxy-29,getmaxx-25,getmaxy-26);
  line(getmaxx-30,getmaxy-3,getmaxx-25,getmaxy-10);
  line(getmaxx,getmaxy-29,getmaxx-5,getmaxy-26);

  SetTextStyle(Smallfont,Horizdir,5);
  SetTextJustify(CenterText, CenterText);
  s := 'Zurck mit';
  outTextxy(getmaxx-80,getmaxy-18,s);
  SetTextStyle(Smallfont,Horizdir,6);

  Aktuell := 1;
  for i := 1 to menue[Mfenster].Punktanzahl do
  begin
    if menue[Mfenster].Punkt[i].Wahl = true then
    begin
      Aktuell := i;
      break;
    end
    else aktuell := 0;
  end;
  {Hoehe und Breite des Fensters berechnen}
  Hoehe    := Abstandrahmen * 2;
  Breite   := Abstandrahmen * 2+textwidth(menue[Mfenster].titel);
  Schrifty[1] := Abstandrahmen;
  for i := 1 to menue[Mfenster].Punktanzahl do
  begin
    Hoehe := hoehe + Abstandschrift + textheight(menue[Mfenster].Punkt[i].Name);

    if not (menue[Mfenster].Punkt[i].zahl) then
    begin
      if menue[Mfenster].Punkt[i].Eing then
      begin
        if Abstandrahmen * 2 + AbstandEing +
           textwidth(menue[Mfenster].Punkt[i].Name) > Breite then
           Breite := Abstandrahmen * 2 + AbstandEing +
                     textwidth(menue[Mfenster].Punkt[i].Name);
      end
      else
      begin
        if Abstandrahmen * 2 +
           textwidth(menue[Mfenster].Punkt[i].Name) > Breite then
           Breite := Abstandrahmen * 2 +
                     textwidth(menue[Mfenster].Punkt[i].Name);
      end;
    end
    else
    begin
      if Abstandrahmen * 2 + Abstandwert +
         textwidth(menue[Mfenster].Punkt[i].Name) > Breite then
         Breite := Abstandrahmen * 2 +
                   Abstandwert +
                   textwidth(menue[Mfenster].Punkt[i].Name);
    end;

    if i <> 1 then
      schrifty[i] := schrifty[i-1] + Abstandschrift +
                     textheight(menue[Mfenster].Punkt[i].Name);
  end;


  {Start der Tastaturabfrage}

  key     := ' ';
  while key <> chr(27) do
  begin

    SetTextJustify(CenterText, CenterText);
    setcolor(lightred);
    outTextxy(Mittex,Mittey - Hoehe div 2,
              menue[Mfenster].Titel);

    setcolor(Lightgreen);
    line(Mittex - Breite div 2,Mittey - Hoehe div 2,
         Mittex - Breite div 2,Mittey + Hoehe div 2);
    line(Mittex + Breite div 2,Mittey - Hoehe div 2,
         Mittex + Breite div 2,Mittey + Hoehe div 2);
    line(Mittex - Breite div 2,Mittey + Hoehe div 2,
         Mittex + Breite div 2,Mittey + Hoehe div 2);
    line(Mittex - Breite div 2,
         Mittey - Hoehe div 2,
         Mittex - textwidth(menue[Mfenster].Titel) div 2 -2,
         Mittey - Hoehe div 2);
    line(Mittex + Breite div 2,
         Mittey - Hoehe div 2,
         Mittex + textwidth(menue[Mfenster].Titel) div 2 +2,
         Mittey - Hoehe div 2);

    for i := 1 to menue[Mfenster].Punktanzahl do
    begin
      if (menue[MFenster].Punkt[i].eing = true) and (aktuell=i) then
      begin
        setcolor(lightblue);
        SetTextJustify(LeftText, TopText);
        outtextxy(Mittex + Breite div 2 - AbstandEing +5,
                  Mittey - Hoehe div 2 + Schrifty[aktuell],
                  menue[Mfenster].Punkt[aktuell].str);
      end;
      if (i = aktuell) then setcolor(white) else setcolor(lightgray);
      if (menue[Mfenster].Punkt[i].Zahl = false) and
         (menue[Mfenster].Punkt[i].Wahl = false) then setcolor(green);
      SetTextJustify(LeftText, TopText);
      outtextxy(Mittex - Breite div 2 + Abstandrahmen,
                Mittey - Hoehe div 2 + Schrifty[i],
                menue[Mfenster].Punkt[i].Name);

      if (menue[Mfenster].Punkt[i].Zahl) then
      begin
        if (MFenster = F_Skill) and (i = 2) then
        begin
          if menue[MFenster].punkt[i].wert = 1 then s:='schlecht';
          if menue[MFenster].punkt[i].wert = 2 then s:='normal';
          if menue[MFenster].punkt[i].wert = 3 then s:='gut';
          if menue[MFenster].punkt[i].wert = 4 then s:='sehr gut';
        end
        else
        if ((MFenster = F_Spieler1) or (MFenster = F_Spieler2) or
            (MFenster = F_Spieler3) or (MFenster = F_Spieler4)) then
        begin
          if i=2 then
          begin
            if menue[MFenster].punkt[i].wert = 3 then s:='Profi';
            if menue[MFenster].punkt[i].wert = 2 then s:='Amateur';
            if menue[MFenster].punkt[i].wert = 1 then s:='Anfnger';
          end
          else if ((i=3) or (i=4)) then
          begin
            if menue[MFenster].punkt[i].wert  = 0 then s:='ja'
            else s:='nein';
          end;
        end
        else str(menue[Mfenster].Punkt[i].Wert,s);
        if i <> aktuell then setcolor(blue) else setcolor(lightblue);
        SetTextJustify(RightText, TopText);
        outtextxy(Mittex + Breite div 2 - Abstandrahmen,
                  Mittey - Hoehe div 2 + Schrifty[i],s);
      end;
    end;


    {Blinkender Cursor}

    repeat
    inc(j);
    if j mod 100 = 0 then DP3D(j);
    if (menue[Mfenster].Punkt[aktuell].eing) then
    begin
      SetTextJustify(LeftText, TopText);
      i:=length(menue[Mfenster].Punkt[aktuell].str)+1;
      s:='';
      for k:=1 to i-1 do s:= s+' ';
      s:=s+'_';

      if j mod 301 = 0 then
      begin
      if j mod 1 = 0 then
      begin
        setcolor(black);
        outtextxy(Mittex + Breite div 2 - AbstandEing +5,
                  Mittey - Hoehe div 2 + Schrifty[aktuell],s);
      if j mod 2 = 0 then
        setcolor(lightblue);
        outtextxy(Mittex + Breite div 2 - AbstandEing +5,
                  Mittey - Hoehe div 2 + Schrifty[aktuell],s);
      end;
      end;
    end;
    if j> 2000*pi then j:=0;
    until keypressed;
    setcolor(black);
    outtextxy(Mittex + Breite div 2 - AbstandEing +5,
              Mittey - Hoehe div 2 + Schrifty[aktuell],s);


    key1 := ' ';
    while keypressed do
    begin
      key := readkey;
      if key = chr(0) then key1 := readkey;
    end;
    if ((key1 = char(77)) or (key1 = char(75))
        or (key1 = chr(13))) and
       (menue[Mfenster].Punkt[aktuell].zahl) then
    begin
      setcolor(black);
      SetTextJustify(RightText, TopText);
      if (MFenster = F_Skill) and (Aktuell = 2) then
      begin
        if menue[MFenster].punkt[aktuell].wert = 1 then s:='schlecht';
        if menue[MFenster].punkt[aktuell].wert = 2 then s:='normal';
        if menue[MFenster].punkt[aktuell].wert = 3 then s:='gut';
        if menue[MFenster].punkt[aktuell].wert = 4 then s:='sehr gut';
      end
      else
      if ((MFenster = F_Spieler1) or (MFenster = F_Spieler2) or
         (MFenster = F_Spieler3) or (MFenster = F_Spieler4)) then
      begin
        if aktuell=2 then
        begin
          if menue[MFenster].punkt[aktuell].wert = 3 then s:='Profi';
          if menue[MFenster].punkt[aktuell].wert = 2 then s:='Amateur';
          if menue[MFenster].punkt[aktuell].wert = 1 then s:='Anfnger';
        end
        else if ((aktuell=3) or (aktuell=4)) then
        begin
          if menue[MFenster].punkt[aktuell].wert  = 0 then s:='ja'
          else s:='nein';
        end;
      end
      else str(menue[Mfenster].Punkt[aktuell].Wert,s);
      outtextxy(Mittex + Breite div 2 - Abstandrahmen,
                Mittey - Hoehe div 2 + Schrifty[Aktuell],s);
      if (key1 = char(77)) or (key1 = chr(13)) then
      begin
        if (MFenster = F_Skill) and (aktuell = 1) then
        begin
          if (menue[MFenster].punkt[aktuell].wert) = 9
          then (menue[MFenster].punkt[aktuell].wert) := 16
          else
          if (menue[MFenster].punkt[aktuell].wert) = 16
          then (menue[MFenster].punkt[aktuell].wert) := 36
          else
          if (menue[MFenster].punkt[aktuell].wert) = 36
          then (menue[MFenster].punkt[aktuell].wert) := 64
          else
          if (menue[MFenster].punkt[aktuell].wert) = 64
          then (menue[MFenster].punkt[aktuell].wert) := 9;
        end
        else
          inc(menue[MFenster].punkt[aktuell].wert);
        if menue[MFenster].punkt[aktuell].wert >
           menue[MFenster].punkt[aktuell].max then
           menue[MFenster].punkt[aktuell].wert :=
           menue[MFenster].punkt[aktuell].min;
      end;
      if key1 = char(75) then
      begin
        if (MFenster = F_Skill) and (aktuell = 1) then
        begin
          if (menue[MFenster].punkt[aktuell].wert) = 64
          then (menue[MFenster].punkt[aktuell].wert) := 36
          else
          if (menue[MFenster].punkt[aktuell].wert) = 36
          then (menue[MFenster].punkt[aktuell].wert) := 16
          else
          if (menue[MFenster].punkt[aktuell].wert) = 16
          then (menue[MFenster].punkt[aktuell].wert) := 9
          else
          if (menue[MFenster].punkt[aktuell].wert) = 9
          then (menue[MFenster].punkt[aktuell].wert) := 64;
        end
        else
          dec(menue[MFenster].punkt[aktuell].wert);
        if menue[MFenster].punkt[aktuell].wert <
           menue[MFenster].punkt[aktuell].min then
           menue[MFenster].punkt[aktuell].wert :=
           menue[MFenster].punkt[aktuell].max;
      end;
      setcolor(lightblue);
      SetTextJustify(RightText, TopText);
      if (MFenster = F_Skill) and (Aktuell = 2) then
      begin
        if menue[MFenster].punkt[aktuell].wert = 1 then s:='schlecht';
        if menue[MFenster].punkt[aktuell].wert = 2 then s:='normal';
        if menue[MFenster].punkt[aktuell].wert = 3 then s:='gut';
        if menue[MFenster].punkt[aktuell].wert = 4 then s:='sehr gut';
      end
      else
      if ((MFenster = F_Spieler1) or (MFenster = F_Spieler2) or
         (MFenster = F_Spieler3) or (MFenster = F_Spieler4)) then
      begin
        if aktuell=2 then
        begin
          if menue[MFenster].punkt[aktuell].wert = 3 then s:='Profi';
          if menue[MFenster].punkt[aktuell].wert = 2 then s:='Amateur';
          if menue[MFenster].punkt[aktuell].wert = 1 then s:='Anfnger';
        end
        else if ((aktuell=3) or (aktuell=4)) then
        begin
          if menue[MFenster].punkt[aktuell].wert  = 0 then s:='ja'
          else s:='nein';
        end;
      end
      else
      begin
        str(menue[Mfenster].Punkt[aktuell].Wert,s);
      end;
      outtextxy(Mittex + Breite div 2 - Abstandrahmen,
                Mittey - Hoehe div 2 + Schrifty[Aktuell],s);
      sound(600);
      delay(10);
      nosound;
    end;

    if (key1 = char(80)) or (key1 = char(72)) then
    begin
      setcolor(lightgray);
      SetTextJustify(LeftText, TopText);
      outtextxy(Mittex - Breite div 2 + Abstandrahmen,
                Mittey - Hoehe div 2 + Schrifty[aktuell],
                menue[Mfenster].Punkt[aktuell].Name);
      if (menue[Mfenster].Punkt[aktuell].zahl) then
      begin
        setcolor(blue);
        SetTextJustify(RightText, TopText);
        if (MFenster = F_Skill) and (Aktuell = 2) then
        begin
          if menue[MFenster].punkt[aktuell].wert = 1 then s:='schlecht';
          if menue[MFenster].punkt[aktuell].wert = 2 then s:='normal';
          if menue[MFenster].punkt[aktuell].wert = 3 then s:='gut';
          if menue[MFenster].punkt[aktuell].wert = 4 then s:='sehr gut';
        end
        else
        if ((MFenster = F_Spieler1) or (MFenster = F_Spieler2) or
            (MFenster = F_Spieler3) or (MFenster = F_Spieler4)) then
        begin
        if aktuell=2 then
        begin
          if menue[MFenster].punkt[aktuell].wert = 3 then s:='Profi';
          if menue[MFenster].punkt[aktuell].wert = 2 then s:='Amateur';
          if menue[MFenster].punkt[aktuell].wert = 1 then s:='Anfnger';
        end
        else if ((aktuell=3) or (aktuell=4)) then
        begin
          if menue[MFenster].punkt[aktuell].wert  = 0 then s:='ja'
          else s:='nein';
        end;
        end
        else str(menue[Mfenster].Punkt[aktuell].Wert,s);
        outtextxy(Mittex + Breite div 2 - Abstandrahmen,
                  Mittey - Hoehe div 2 + Schrifty[aktuell],s);
      end;

      if (key1 = char(80)) then
      begin
        inc(aktuell);
        if aktuell > menue[MFenster].punktanzahl then aktuell :=1;
      end;
      if key1 = char(72) then
      begin
        dec(aktuell);
        if aktuell < 1 then aktuell := menue[MFenster].punktanzahl;
      end;

      setcolor(white);
      SetTextJustify(LeftText, TopText);
      outtextxy(Mittex - Breite div 2 + Abstandrahmen,
                Mittey - Hoehe div 2 + Schrifty[aktuell],
                menue[Mfenster].Punkt[aktuell].Name);
      if (menue[Mfenster].Punkt[aktuell].zahl) then
      begin
      setcolor(lightblue);
      SetTextJustify(RightText, TopText);
      if (MFenster = F_Skill) and (Aktuell = 2) then
      begin
        if menue[MFenster].punkt[aktuell].wert = 1 then s:='schlecht';
        if menue[MFenster].punkt[aktuell].wert = 2 then s:='normal';
        if menue[MFenster].punkt[aktuell].wert = 3 then s:='gut';
        if menue[MFenster].punkt[aktuell].wert = 4 then s:='sehr gut';
      end
      else
      if ((MFenster = F_Spieler1) or (MFenster = F_Spieler2) or
         (MFenster = F_Spieler3) or (MFenster = F_Spieler4)) then
      begin
        if aktuell=2 then
        begin
          if menue[MFenster].punkt[aktuell].wert = 3 then s:='Profi';
          if menue[MFenster].punkt[aktuell].wert = 2 then s:='Amateur';
          if menue[MFenster].punkt[aktuell].wert = 1 then s:='Anfnger';
        end
        else if ((aktuell=3) or (aktuell=4)) then
      begin
        if menue[MFenster].punkt[aktuell].wert  = 0 then s:='ja'
        else s:='nein';
      end;
      end
      else str(menue[Mfenster].Punkt[aktuell].Wert,s);
      outtextxy(Mittex + Breite div 2 - Abstandrahmen,
                Mittey - Hoehe div 2 + Schrifty[aktuell],s);
      end;
    end;

    {Eingabe verarbeiten}
    if ((key1 <> chr(72)) and (key1 <> chr(80)) and (key1 <> chr(77)) and
       (key1 <> chr(75))  and (key <> chr(13)) and (key <> chr(27))) and
       (menue[Mfenster].Punkt[aktuell].eing) then
    begin
      SetTextJustify(LeftText, TopText);
      if key = char(8) then
      begin
        setcolor(black);
        outtextxy(Mittex + Breite div 2 - AbstandEing +5,
                Mittey - Hoehe div 2 + Schrifty[aktuell],
                menue[Mfenster].Punkt[aktuell].str);
        menue[Mfenster].Punkt[aktuell].str :=
          Copy(menue[Mfenster].Punkt[aktuell].str, 1,
               length(menue[Mfenster].Punkt[aktuell].str)-1);
      end
      else
      begin
        if length(menue[Mfenster].Punkt[aktuell].str + key) < 12 then
        begin
          menue[Mfenster].Punkt[aktuell].str :=
            menue[Mfenster].Punkt[aktuell].str + key;
          sound(400);
          delay(10);
          nosound;
        end
        else
        begin
          sound(800);
          delay(30);
          nosound;
        end;
      end;
      setcolor(lightblue);
      outtextxy(Mittex + Breite div 2 - AbstandEing +5,
                Mittey - Hoehe div 2 + Schrifty[aktuell],
                menue[Mfenster].Punkt[aktuell].str);

      if Mfenster = F_Spieler1 then
        menue[F_Spieler].Punkt[1].Name := menue[Mfenster].Punkt[aktuell].str;
      if Mfenster = F_Spieler2 then
        menue[F_Spieler].Punkt[2].Name := menue[Mfenster].Punkt[aktuell].str;
      if Mfenster = F_Spieler3 then
        menue[F_Spieler].Punkt[3].Name := menue[Mfenster].Punkt[aktuell].str;
      if Mfenster = F_Spieler4 then
        menue[F_Spieler].Punkt[4].Name := menue[Mfenster].Punkt[aktuell].str;

    end;

    if key = chr(13) then
    begin
      if (menue[Mfenster].Punkt[aktuell].gofen > 0) then
      begin
        setcolor(black);
        setfillstyle(solidFill, black);
        bar(Mittex - Breite div 2 ,Mittey - Hoehe div 2 - 5,
            Mittex + Breite div 2 ,Mittey + Hoehe div 2);
        Fenster(menue[Mfenster].Punkt[Aktuell].goFen,e);
      end
      else
      begin
        if (menue[Mfenster].Punkt[aktuell].gofen = -1) then
        begin
          beginnen := true;
          key := chr(27);
        end;
        if (menue[Mfenster].Punkt[aktuell].gofen = -2) then
        begin
          key :=chr(27);
          beenden := true;
        end;

      end;
    end;
  end;
  setcolor(black);
  setfillstyle(solidFill, black);
  bar(Mittex - Breite div 2 ,Mittey - Hoehe div 2 - 5,
      Mittex + Breite div 2 ,Mittey + Hoehe div 2);
end;

procedure Intro(sofort: boolean);
var
  Titel : array[1..8] of record
                         x,y     : integer;
                         Zeichen : char;
                         open    : boolean;
                         end;
  i     : integer;
  fertig: boolean;
begin
  for i := 1 to 8 do
  begin
    titel[i].x := (getmaxx div 8) * i -50;
    titel[i].y := 50;
    titel[i].open := false;
  end;
  titel[1].Zeichen := 'Z';
  titel[2].Zeichen := 'A';
  titel[3].Zeichen := 'H';
  titel[4].Zeichen := 'L';
  titel[5].Zeichen := 'O';
  titel[6].Zeichen := 'R';
  titel[7].Zeichen := 'I';
  titel[8].Zeichen := 'E';
  for i := 1 to 8 do
  begin
    setcolor(red);
    rectangle(titel[i].x,titel[i].y,
              titel[i].x+50,titel[i].y+80);
    setfillstyle(solidfill,brown);
    floodfill(titel[i].x+1,titel[i].y+1,red);
    end;
  if not sofort then
  begin
    delay(2000);
  end;
  repeat
    repeat
      i:=random(8)+1;
    until not titel[i].open;
    titel[i].open := true;
    setfillstyle(solidfill,green);
    floodfill(titel[i].x+1,titel[i].y+1,red);
    SetTextStyle(1,Horizdir,5);
    SetTextJustify(CenterText, Centertext);
    setcolor(lightred);
    outTextxy(titel[i].x+25,
              titel[i].y+35,
              titel[i].zeichen);
    if not sofort then
    begin
      sound(300);
      delay(100);
      nosound;
      delay(650);
    end;
    fertig := true;
    for i := 1 to 8 do if titel[i].open= false then fertig := false;

  until fertig;
  sound(600);
  delay(100);
  sound(400);
  delay(100);
  nosound;
end;

procedure Start;
begin
  {$I-}
  reset(Datei);
  if IOResult = 0 then read(Datei,menue);
  close(Datei);
  {$I+}
  cleardevice;
  Intro(false);
  beenden := false;
  repeat
  Beginnen := false;
  Fenster(F_Haupt,e);
  if beginnen then
  begin
    cleardevice;
    Aufbau;
    Spiel;
    cleardevice;
    Intro(true);
  end;

  until beenden;
end;


procedure init;
var
  i,j           : integer;
begin
  randomize;


  Graphdriver := Detect;
  InitGraph(GraphDriver,Graphmode,'');
  Errorcode := Graphresult;
  if Errorcode <> 0 then
  begin
    Writeln('Grafikfehler: ',GraphErrorMsg(Errorcode));
    Halt(1);
  end;
  {Fr 3D-Logo}
  xr := 50;
  yr := 30;
  mid.x := 150;
  mid.y := getmaxy-100;



  Mittex := getmaxx div 2;
  Mittey := getmaxy div 2;

  with menue[F_Haupt] do
  begin
    Titel       := 'Hauptmen';
    Punktanzahl := 4;
    with Punkt[1] do
    begin
      Name      := 'Spiel starten';
      Zahl      := false;
      Wahl      := True;
      GoFen     := -1;
      Eing      := false;
    end;
    with Punkt[2] do
    begin
      Name      := 'Spielereinstellungen';
      Zahl      := false;
      Wahl      := True;
      goFen     := F_Spieler;
      Eing      := false;
    end;
    with Punkt[3] do
    begin
      Name      := 'Schwierigkeitsgrad';
      Zahl      := false;
      Wahl      := True;
      goFen     := F_Skill;
      Eing      := false;
    end;
    with Punkt[4] do
    begin
      Name      := 'Spiel beenden';
      Zahl      := false;
      Wahl      := True;
      goFen     := -2;
      Eing      := false;
    end;
  end;
  with menue[F_Skill] do
  begin
    Titel       := 'Schwierigkeitsgrad';
    Punktanzahl := 2;
    with Punkt[1] do
    begin
      Name      := 'Kartenanzahl';
      Zahl      := True;
      Wert      := 36;
      Max       := 64;
      Min       := 9;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[2] do
    begin
      Name      := 'Computerstrke';
      Zahl      := true;
      Wert      := 2;
      Max       := 4;
      Min       := 1;
      Wahl      := True;
      goFen     := 0;
      Eing      := false;
    end;
  end;
  with menue[F_Spieler] do
  begin
    Titel       := 'Spielereinstellungen';
    Punktanzahl := 4;
    with Punkt[1] do
    begin
      Name      := 'Roger';
      Zahl      := false;
      Wahl      := True;
      GoFen     := F_Spieler1;
      Eing      := false;
    end;
    with Punkt[2] do
    begin
      Name      := 'Guybrush';
      Zahl      := false;
      Wahl      := True;
      GoFen     := F_Spieler2;
      Eing      := false;
    end;
    with Punkt[3] do
    begin
      Name      := 'Bernhard';
      Zahl      := false;
      Wahl      := True;
      GoFen     := F_Spieler3;
      Eing      := false;
    end;
    with Punkt[4] do
    begin
      Name      := 'Simon';
      Zahl      := false;
      Wahl      := True;
      GoFen     := F_Spieler4;
      Eing      := false;
    end;
  end;
  with menue[F_Spieler1] do
  begin
    Titel       := '1. Spieler';
    Punktanzahl := 4;
    with Punkt[1] do
    begin
      Name      := 'Name:';
      Zahl      := false;
      Wahl      := True;
      GoFen     := 0;
      Eing      := true;
      Str       := 'Roger';
    end;
    with Punkt[2] do
    begin
      Name      := 'Anspruch:';
      Zahl      := true;
      Wert      := 2;
      Max       := 3;
      Min       := 1;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[3] do
    begin
      Name      := 'Computer?';
      Zahl      := true;
      Wert      := 1;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[4] do
    begin
      Name      := 'Spielt mit?';
      Zahl      := true;
      Wert      := 0;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
  end;
  with menue[F_Spieler2] do
  begin
    Titel       := '2. Spieler';
    Punktanzahl := 4;
    with Punkt[1] do
    begin
      Name      := 'Name:';
      Zahl      := false;
      Wahl      := True;
      GoFen     := 0;
      Eing      := true;
      Str       := 'Guybrush';
    end;
    with Punkt[2] do
    begin
      Name      := 'Anspruch:';
      Zahl      := true;
      Wert      := 2;
      Max       := 3;
      Min       := 1;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[3] do
    begin
      Name      := 'Computer?';
      Zahl      := true;
      Wert      := 1;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[4] do
    begin
      Name      := 'Spielt mit?';
      Zahl      := true;
      Wert      := 0;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
  end;
  with menue[F_Spieler3] do
  begin
    Titel       := '3. Spieler';
    Punktanzahl := 4;
    with Punkt[1] do
    begin
      Name      := 'Name:';
      Zahl      := false;
      Wahl      := True;
      GoFen     := 0;
      Eing      := true;
      Str       := 'Bernhard';
    end;
    with Punkt[2] do
    begin
      Name      := 'Anspruch:';
      Zahl      := true;
      Wert      := 2;
      Max       := 3;
      Min       := 1;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[3] do
    begin
      Name      := 'Computer?';
      Zahl      := true;
      Wert      := 1;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[4] do
    begin
      Name      := 'Spielt mit?';
      Zahl      := true;
      Wert      := 0;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
  end;
  with menue[F_Spieler4] do
  begin
    Titel       := '4. Spieler';
    Punktanzahl := 4;
    with Punkt[1] do
    begin
      Name      := 'Name:';
      Zahl      := false;
      Wahl      := True;
      GoFen     := 0;
      Eing      := true;
      Str       := 'Simon';
    end;
    with Punkt[2] do
    begin
      Name      := 'Anspruch:';
      Zahl      := true;
      Wert      := 2;
      Max       := 3;
      Min       := 1;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[3] do
    begin
      Name      := 'Computer?';
      Zahl      := true;
      Wert      := 1;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
    with Punkt[4] do
    begin
      Name      := 'Spielt mit?';
      Zahl      := true;
      Wert      := 0;
      Max       := 1;
      Min       := 0;
      Wahl      := True;
      GoFen     := 0;
      Eing      := false;
    end;
  end;


  Hoehe  := getmaxy - Balken;
  Breite := getmaxx;
  Start;
end;

begin
  assign(Datei,'option.sav');

  init;

  {$I-}

  rewrite(Datei);
  write(datei,menue);
  close(datei);
  {$I+}
  cleardevice;
  write('Have a n.i.c.e. Windows...');
end.